CREATE OR REPLACE procedure tprint (
   i_page_num in varchar2 default '1') is

   more_rows boolean;

   cur_page number := to_number(i_page_num);
   min_row number;
   max_row number;

   i_num_rows constant number := 5;

begin
   min_row := (cur_page - 1) * i_num_rows + 1;
   max_row := min_row + i_num_rows - 1;
   more_rows := owa_util.tableprint (
      'scott.emp',
      'border=1',
      owa_util.HTML_TABLE,
      'job, ename, hiredate, sal',
      'order by job, ename',
      'Job, Employee Name, Date Hired, Salary',
      min_row,
      max_row);
   -- Put "Prev" hyperlink if min_row > 1
   if cur_page > 1 then
      htp.anchor('tprint?i_page_num=' || (cur_page - 1),'Previous');
   end if;
   -- Put a "Next" if there are more rows in the query
   if more_rows then
      htp.anchor('tprint?i_page_num=' || (cur_page + 1),'Next');
   end if;
EXCEPTION
   when others then
      htp.print(dbms_utility.format_error_stack);
end;
  
/

