/*
|| Script to create the required package specifications
|| Since there are multiple packages, with multiple dependencies,
|| we'll create the bodies in a separate script after the specs exist
*/
CREATE OR REPLACE package forum is

   procedure create_msg_form ( i_parent_msg in varchar2 default null);

   procedure save_message (
      i_parent_msg in varchar2 default null,
	  i_subject in varchar2 default null,
	  i_msg_body in varchar2 default null );

   procedure current_forum_list;

   procedure view_message (
      i_thread_id in varchar2 default null,
	  i_hierarchy_flag in varchar2 default null );

end; 
/
/*---------------------------------------------------------------------------*/
CREATE OR REPLACE package forum_members is

   procedure create_user_form;

end; 
/
/*---------------------------------------------------------------------------*/
CREATE OR REPLACE package forum_users is

   procedure create_user_form;

   procedure login_form (
      i_username in varchar2 default null,
      i_message in varchar2 default null );

   function get_current_user return varchar2;

   procedure login (
      i_username in varchar2,
	  i_password in varchar2) ;

   procedure save_user_info (
      i_username in varchar2 default null,
	  i_name in varchar2 default null,
	  i_password in varchar2 default null,
	  i_email_address in varchar2 default null,
	  i_desc in varchar2 default null ) ;

end; 
/
/*---------------------------------------------------------------------------*/
CREATE OR REPLACE package general_form is
   /*
   || Prints a single two-column table row; column 1 has a description,
   || column 2 has either an input element plain text
   */
   procedure print_input_row (
      i_label in varchar2,
	  i_input_name in varchar2,
	  i_hidden_flag in boolean default false,
	  i_size in number default 40,
	  i_value in varchar2 default null ) ;

   /*
   || Create a two-column table; the second column is a <textarea> field
   */
   procedure print_textarea_row (
      i_label in varchar2,
	  i_input_name in varchar2,
 	  i_cols in number default 40,
 	  i_rows in number default 7 );

end; 
/
